package brain.gui.table;

import java.awt.Component;
import java.lang.reflect.Field;

import javax.swing.DefaultCellEditor;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.TableCellEditor;

public class AccessibleObjectTableCellEditor extends DefaultCellEditor implements TableCellEditor {
  private static final long serialVersionUID = 1L;

  public AccessibleObjectTableCellEditor() {
    super(new JTextField());
    this.setClickCountToStart(1);
  }

  @Override
  public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
    final JTextField textField = (JTextField) super.getTableCellEditorComponent(table, value, isSelected, row, column);
    textField.setBorder(null);
    if (value instanceof Field) {
      final Field field = (Field) value;
      try {
        final Object fieldValue = field.get(((ObjectTableModel) table.getModel()).getObject());
        if (fieldValue == null){
          textField.setText("null");
        }else{
          final String string = AccessibleObjectTableCellRenderer.getStringValue(fieldValue);
          textField.setText(string);
        }
      } catch (IllegalArgumentException e) {
        e.printStackTrace();
      } catch (IllegalAccessException e) {
        e.printStackTrace();
      }
    } else {
      //      System.out.println(this.getClass().getName() + " should not be used for type " + value.getClass().getName());
    }
    return textField;
  }
}