package brain.gui.table;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractCellEditor;
import javax.swing.JTable;
import javax.swing.JToggleButton;
import javax.swing.table.TableCellEditor;

/**
 * @author Mathias Linkerhand
 * @version 2013-01-31
 * @since 2011
 */
public class BooleanTableCellEditor extends AbstractCellEditor implements TableCellEditor {
  private static final long serialVersionUID = 1L;
  private JToggleButton     toggleButton;

  public BooleanTableCellEditor() {
    this.toggleButton = new JToggleButton();
  }

  @Override
  public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
    this.toggleButton.setText(((Boolean) value).booleanValue() ? "on" : "off");
    this.toggleButton.setEnabled(table.getModel().isCellEditable(row, column));
    this.toggleButton.setSelected((Boolean) value);
    this.toggleButton.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        fireEditingStopped();
      }
    });
    return toggleButton;
  }

  @Override
  public Boolean getCellEditorValue() {
    return toggleButton.isSelected();
  }
}
