package brain.gui.table;

import java.awt.Component;

import javax.swing.JTable;
import javax.swing.JToggleButton;
import javax.swing.table.DefaultTableCellRenderer;

/**
 * @author Mathias Linkerhand
 * @version 2013-01-31
 * @since 2011
 */
public class BooleanTableCellRenderer extends DefaultTableCellRenderer {
  private static final long serialVersionUID = 1L;
  private JToggleButton     toggleButton;

  public BooleanTableCellRenderer() {
    this.toggleButton = new JToggleButton();
  }

  @Override
  public Component getTableCellRendererComponent(final JTable table, final Object value, final boolean isSelected, final boolean hasFocus, final int row,
      final int column) {
    this.toggleButton.setEnabled(table.getModel().isCellEditable(row, column));
    this.toggleButton.getModel().setPressed((Boolean) value);
    this.toggleButton.setText(((Boolean) value).booleanValue() ? "on" : "off");
    return this.toggleButton;
  }
}
