package utils;

import java.util.Date;

/**
 * Evaluation of time statistics.
 * 
 * @author Mathias Linkerhand
 * @version 2009-10-22
 */
public class Timer {
  private Date   start;
  private Date   stop;
  private double progress;

  public Timer() {
  }

  public long getElapsed() {
    if (this.stop != null) {
      return this.stop.getTime() - this.start.getTime();
    } else {
      return new Date().getTime() - this.start.getTime();
    }
  }

  public long getRemaining(final double progress) {
    return Math.round((1.0 / progress - 1.0) * this.getElapsed());
  }

  public double getProgress() {
    return this.progress;
  }

  public void setProgress(final double progress) {
    this.progress = progress;
  }

  public void start() {
    this.setStart(new Date());
    this.setStop(null);
  }

  public Date getStart() {
    return start;
  }

  private void setStart(final Date start) {
    this.start = start;
  }

  public void stop() {
    if (this.stop == null) {
      this.setStop(new Date());
    }
  }

  public Date getStop() {
    return stop;
  }

  private void setStop(final Date stop) {
    this.stop = stop;
  }
}